//**********************************************************
//                       GPCI.H
//
// Includes Definitions for Command Byte, Start & Stop Bytes
// And other globally common Defines
//
//**********************************************************


//**********************************************************
//  Command Byte Bit Definitions (Add together for result)
//**********************************************************
//
// D0 = Read/Write
// D1 = Auto Inc Sub / Single Sub Multi  read or write
// D2 = Slow or Fast GPCI Speed
// D3 = Reserved for later use
// D4 = Reserved for later use
// D5 = Reserved for later use
// D6 = Reserved for later use
// D7 = Echo Data Packet (For Testing Only)
//
#define  GPCI_READ     0x01
#define  GPCI_WRITE    0x00
#define  GPCI_AUTOINC  0x02
#define  GPCI_NOINC    0x00
#define  GPCI_SLOW     0x04
#define  GPCI_FAST     0x00
#define  GPCI_RES1_ON  0x08
#define  GPCI_RES1_OFF 0x00
#define  GPCI_RES2_ON  0x10
#define  GPCI_RES2_OFF 0x00
#define  GPCI_RES3_ON  0x20
#define  GPCI_RES3_OFF 0x00
#define  GPCI_RESEND   0x40
#define  GPCI_NORESEND 0x00
#define  GPCI_ECHO_ON  0x80
#define  GPCI_ECHO_OFF 0x00
//************ END OF Command Byte Definitions
//****************************************************************
//              Start and Stop Byte Definitions
//****************************************************************
#define STARTBYTE 'U'            //-- Start of serial Packet
#define STOPBYTE  'f'            //-- End of serial Packet

//************ END OF Start and Stop Byte Definitions



